!  Functions for A-B coupling expressed as spline
!  (unchanged from version provided by RS)

c#%#%#                                                                          
          subroutine raster_BA(iunit,neps)                                             1
          implicit double precision (a-h,o-z)                                  2
          parameter (ndat=260000,ndx=100,ndy=50,ndz=50)
          common/surfac_BA/en(ndat,5),                                              3
     *    px(ndat,5),py(ndat,5),pz(ndat,5),                                           
     *    pxy(ndat,5),pxz(ndat,5),pyz(ndat,5),                                        
     *    pxyz(ndat,5)                                                            
          common/gridx_BA/    x(ndx),nx                                            4
          common/gridy_BA/    y(ndy),ny                                            5
          common/gridz_BA/    z(ndz),nz                                            6
c                                                                               
          rewind iunit                                                          7
          READ (iunit,*) NX,(X(I),I=1,NX)                                           9
          READ (iunit,*) NY,(Y(I),I=1,NY)
          READ (iunit,*) NZ,(Z(I),I=1,NZ)                                          11
          NXYZ=NX*NY*NZ                                                       12
          READ (iunit,*) (EN(I,neps),I=1,NXYZ)                                          13
          READ (iunit,*) (PX(I,neps),I=1,NXYZ)                                          14
          READ (iunit,*) (PY(I,neps),I=1,NXYZ)                                          15
          READ (iunit,*) (PZ(I,neps),I=1,NXYZ)                                          16
          READ (iunit,*) (PXY(I,neps),I=1,NXYZ)                                         17
          READ (iunit,*) (PXZ(I,neps),I=1,NXYZ)                                         18
          READ (iunit,*) (PYZ(I,neps),I=1,NXYZ)                                         19
          READ (iunit,*) (PXYZ(I,neps),I=1,NXYZ)                                        20
C                                                                               
!         write(6,300)                                                          
!         do 10 I=1,nxyz                                                        
!10        write(6,100)neps,i,en(i,neps),px(i,neps),py(i,neps),
!     *    pz(i,neps)                                 
!         write(6,200)                                                          
!         do 20 i=1,nxyz                                                        
!20        write(6,100)neps,i,pxy(i,neps),pxz(i,neps),pyz(i,neps),
!     *    pxyz(i,neps)                           
 100       format(2i7,4f14.6)                                                    
 300       format('  i,         e,       px,      py,      pz')                 
 200       format('  i,       pxy,      pxz,     pyz,     pxyz')                
          return                                                              21
          end                                                                 22
c#%#%#                                                                          
                                                                                

      SUBROUTINE NATURL_BA(R,INDX,FIN,neps)
C                                                                       00031000
C     INDX = 0  :  INTERPOLATED POTENTIAL ONLY                          00032000
C            3  :        "      X,Y,Z-DERIVATIVES                       00033000
C                                                                       00034000
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)                                00035000
      parameter (ndx=100, ndy=50,ndz=50)
      DIMENSION FIN(4),FIJK(64),HI(3),XR(3),U(3,4),R(3)                 00036000
      COMMON /GRIDX_BA/    X(ndx),NX                                       00037000
      COMMON /GRIDY_BA/    Y(ndy),NY                                        00038000
      COMMON /GRIDZ_BA/    Z(ndz),NZ                                        00039000
      DATA UN/1.D0/,TWO/2.D0/,THREE/3.D0/,SIX/6.D0/,IV,JV,KV/3*0/       00040000
C      
  
      save 
!!!!  test!!!!!!!!!!!
      iv=0
      jv=0
      kv=0 
!!!!!!!!!!!!!!!!!!!      
      LS=1                                                                      
      IF(R(1).LT.X(1).OR.R(1).GT.X(NX)) GOTO 110                        00043000
      LS=2                                                              00044000
      IF(R(2).LT.Y(1).OR.R(2).GT.Y(NY)) GOTO 110                        00045000
      LS=3                                                              00046000
      IF(R(3).LT.Z(1).OR.R(3).GT.Z(NZ)) GOTO 110                        00047000
      DO 10 IS=2,NX                                                     00048000
      IF(R(1).LT.X(IS)) GOTO 20                                         00049000
   10 CONTINUE                                                          00050000
   20 DO 30 JS=2,NY                                                     00051000
      IF(R(2).LT.Y(JS)) GOTO 40                                         00052000
   30 CONTINUE                                                          00053000
   40 DO 50 KS=2,NZ                                                     00054000
      IF(R(3).LT.Z(KS)) GOTO 60                                         00055000
   50 CONTINUE                                                          00056000
   60 continue
      IF(IS.NE.IV) GOTO 65                                              00057000
      IF(JS.NE.JV) GOTO 65   
      IF(KS.EQ.KV) GOTO 75                                              00059000
   65 CALL FORMV_BA(IS,JS,KS,FIJK,neps)                                         00060000
      HI(1)=X(IS)-X(IS-1)                                               00061000
      IV=IS                                                             00062000
      HI(2)=Y(JS)-Y(JS-1)                                               00063000
      JV=JS                                                             00064000
      HI(3)=Z(KS)-Z(KS-1)                                               00065000
      KV=KS                                                             00066000
   75 XR(1)=(R(1)-X(IS-1))/HI(1)                                        00067000
      XR(2)=(R(2)-Y(JS-1))/HI(2)                                        00068000
      XR(3)=(R(3)-Z(KS-1))/HI(3)                                        00069000
      IN=INDX                                                           00070000
   90 DO 70 I=1,3                                                       00071000
      IF(I.EQ.IN) GOTO 70                                               00072000
      XR2=XR(I)**2                                                      00073000
      XR3=XR(I)*XR2                                                     00074000
      U(I,1)=-TWO*XR3+THREE*XR2                                         00075000
      U(I,2)=-U(I,1)+UN                                                 00076000
      U(I,3)=HI(I)*(XR3-XR2)                                            00077000
      U(I,4)=HI(I)*(XR3-TWO*XR2+XR(I))                                  00078000
   70 CONTINUE                                                          00079000
      IF(IN.EQ.0) GOTO 80                                               00080000
      U(IN,1)=SIX*(-XR(IN)+1)*XR(IN)/HI(IN)                             00081000
      U(IN,2)=-U(IN,1)                                                  00082000
      U(IN,3)=(THREE*XR(IN)-TWO)*XR(IN)                                 00083000
      U(IN,4)=U(IN,3)-TWO*XR(IN)+UN                                     00084000
   80 FIN(IN+1)=0.D0                                                    00085000
      IJK=1                                                             00086000
      DO 100 K=1,4                                                      00087000
      DO 100 J=1,4                                                      00088000
      UKJ=U(3,K)*U(2,J)                                                 00089000
      DO 100 I=1,4                                                      00090000
      FIN(IN+1)=FIN(IN+1)+FIJK(IJK)*UKJ*U(1,I)                          00091000
  100 IJK=IJK+1                                                         00092000
      IN=IN-1                                                           00093000
      IF(IN.GT.0.AND.INDX.GT.0) GOTO 90                                 00094000
      RETURN                                                            00095000
  110 PRINT 120,LS                                                      00096000
  120 FORMAT( 1X,15('*'),' R(',I1,') SORT DE LA GRILLE')                00097000
      print*,r(ls)                                                              
      RETURN                                                            00098000
      END                                                               00099000
C#%#%#                                                                          
      SUBROUTINE FORMV_BA(I,J,K,G,neps)                                                1
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)                                       2
      parameter (ndat=260000,ndx=100,ndy=50,ndz=50)
      DIMENSION G(64)                                                          3
      COMMON /SURFAC_BA/  F(ndat,5),                                                4
     & PX(ndat,5),PY(ndat,5),PZ(ndat,5),                                      00104000
     & PXY(ndat,5),PXZ(ndat,5),PYZ(ndat,5),                                   00105000
     & PXYZ(ndat,5)                                                       00106000
      COMMON /GRIDX_BA/    X(ndx),NX                                               5
      COMMON /GRIDY_BA/    Y(ndy),NY                                               6
      COMMON /GRIDZ_BA/    Z(ndz),NZ                                               7
C                                                                       00110000
      IJK=(K-1)*NX*NY+(J-1)*NX+I                                               8
      IMJK=IJK-1                                                               9
      IJMK=IJK-NX                                                             10
      IMJMK=IJMK-1                                                            11
      IJKM=IJK-NX*NY                                                          12
      IMJKM=IJKM-1                                                            13
      IJMKM=IJKM-NX                                                           14
      IMJMKM=IJMKM-1                                                          15
C                                                                       00119000
      G( 1)=F(IJK,neps)                                                            16
      G( 2)=F(IMJK,neps)                                                           17
      G( 3)=PX(IJK,neps)                                                           18
      G( 4)=PX(IMJK,neps)                                                          19
      G( 5)=F(IJMK,neps)                                                           20
      G( 6)=F(IMJMK,neps)                                                          21
      G( 7)=PX(IJMK,neps)                                                          22
      G( 8)=PX(IMJMK,neps)                                                         23
      G( 9)=PY(IJK,neps)                                                           24
      G(10)=PY(IMJK,neps)                                                          25
      G(11)=PXY(IJK,neps)                                                          26
      G(12)=PXY(IMJK,neps)                                                         27
      G(13)=PY(IJMK,neps)                                                          28
      G(14)=PY(IMJMK,neps)                                                         29
      G(15)=PXY(IJMK,neps)                                                         30
      G(16)=PXY(IMJMK,neps)                                                        31
      G(17)=F(IJKM,neps)                                                           32
      G(18)=F(IMJKM,neps)                                                          33
      G(19)=PX(IJKM,neps)                                                          34
      G(20)=PX(IMJKM,neps)                                                         35
      G(21)=F(IJMKM,neps)                                                          36
      G(22)=F(IMJMKM,neps)                                                         37
      G(23)=PX(IJMKM,neps)                                                         38
      G(24)=PX(IMJMKM,neps)                                                        39
      G(25)=PY(IJKM,neps)                                                          40
      G(26)=PY(IMJKM,neps)                                                         41
      G(27)=PXY(IJKM,neps)                                                         42
      G(28)=PXY(IMJKM,neps)                                                        43
      G(29)=PY(IJMKM,neps)                                                         44
      G(30)=PY(IMJMKM,neps)                                                        45
      G(31)=PXY(IJMKM,neps)                                                        46
      G(32)=PXY(IMJMKM,neps)                                                       47
      G(33)=PZ(IJK,neps)                                                           48
      G(34)=PZ(IMJK,neps)                                                          49
      G(35)=PXZ(IJK,neps)                                                          50
      G(36)=PXZ(IMJK,neps)                                                         51
      G(37)=PZ(IJMK,neps)                                                          52
      G(38)=PZ(IMJMK,neps)                                                         53
      G(39)=PXZ(IJMK,neps)                                                         54
      G(40)=PXZ(IMJMK,neps)                                                        55
      G(41)=PYZ(IJK,neps)                                                          56
      G(42)=PYZ(IMJK,neps)                                                         57
      G(43)=PXYZ(IJK,neps)                                                         58
      G(44)=PXYZ(IMJK,neps)                                                        59
      G(45)=PYZ(IJMK,neps)                                                         60
      G(46)=PYZ(IMJMK,neps)                                                        61
      G(47)=PXYZ(IJMK,neps)                                                        62
      G(48)=PXYZ(IMJMK,neps)                                                       63
      G(49)=PZ(IJKM,neps)                                                          64
      G(50)=PZ(IMJKM,neps)                                                         65
      G(51)=PXZ(IJKM,neps)                                                         66
      G(52)=PXZ(IMJKM,neps)                                                        67
      G(53)=PZ(IJMKM,neps)                                                         68
      G(54)=PZ(IMJMKM,neps)                                                        69
      G(55)=PXZ(IJMKM,neps)                                                        70
      G(56)=PXZ(IMJMKM,neps)                                                       71
      G(57)=PYZ(IJKM,neps)                                                         72
      G(58)=PYZ(IMJKM,neps)                                                        73
      G(59)=PXYZ(IJKM,neps)                                                        74
      G(60)=PXYZ(IMJKM,neps)                                                       75
      G(61)=PYZ(IJMKM,neps)                                                        76
      G(62)=PYZ(IMJMKM,neps)                                                       77
      G(63)=PXYZ(IJMKM,neps)                                                       78
      G(64)=PXYZ(IMJMKM,neps)
      RETURN     
      END        
c ENDE DES 3DPLINE-PROGRAMMS!                                                   



!**********************************************************

      function vBA_par(r1,r2,alpha,neps)
      implicit real*8 (a-h,o-z)
      dimension x(3),fin(4)


      rmin=2.1+0.0001
      rmax=2.9-0.001
      amin=90+0.0001
      amax=140-0.0001

      rr2=r2
      aa=alpha

      if(rr2.le.rmin)rr2=rmin
      if(rr2.ge.rmax)rr2=rmax
      if(aa.le.amin)aa=amin
      if(aa.ge.amax)aa=amax    

      x(1)=r1  !! dummy variable
      x(2)=aa
      x(3)=rr2

      call naturl_BA(x,0,fin,neps)
      vBA_par=fin(1)

!      write(6,9999)x,vBA_par
! 9999 format(3f12.5,d20.10)

      return
      end 

!**********************************************************

      function vBA_func(r1,r2,alpha)     
!!! construction of V12 potential for B/A crossing

      implicit real*8 (a-h,o-z)


!! symmetrization

      rr1=r1
      rr2=r2
      if(rr1.ge.rr2)goto 1
      rr1=r2
      rr2=r1
 1    continue
     

      eps=1
      r1_dummy=2.2

      rx=vBA_par(r1_dummy,rr2,alpha,2)  !!! evaluation of crossing distance
      de=vBA_par(r1_dummy,rr2,alpha,1)  !!! evaluation of adiab. energy diff.

      w=2*de    !! width
      beta=-4*dlog(0.5d0)/w**2  !! exponent

      beta=eps*beta  !! modification

      vBA_func=0.5*de*dexp(-beta*(rr1-rx)**2)

      vBA_func=1*vBA_func     !!! overall modification 

      return
      end

